/*Rococpy Cloud Custom Materal JS V1.18.0
Copyright 2019 - 2021 Rococpy All rights reserved.*/

const showPopup = (idx) => window.open(`/view/img/${idx}`, "Image", "width=400,height=400"),
      formatBytes = (bytes, decimals = 2) => {
        if (bytes === 0) return '0 Bytes';

        const k = 1024,
              dm = decimals < 0 ? 0 : decimals,
              sizes = ['Bytes', 'KB', 'MB', 'GB', 'TB', 'PB', 'EB', 'ZB', 'YB'],
              i = Math.floor(Math.log(bytes) / Math.log(k));

        return parseFloat((bytes / Math.pow(k, i)).toFixed(dm)) + ' ' + sizes[i];
      },

      progress = (idx, percentage, now, total) => {
        const upidx = `.uploadidx_${idx}`;

        $(`${upidx} .bars`).css("width", `${percentage}%`, 300);
        $(`${upidx} .per`).text(`${percentage.toFixed(2)}%`);
        $(`${upidx} .nowupload`).text(`${formatBytes(now)}`);
        $(`${upidx} .totaluplaod`).text(`${formatBytes(total)}`);

        if (percentage >= 100) {
          $(`${upidx} .upload_main_t`).text(`파일 업로드 완료`);
          $(`${upidx} .per`).text(`100%`);
          $(`.i${$(`${upidx}`).data('tidx')} i`).text('done')

          Alert.open(`총 ${formatBytes(total)}를 업로드 했습니다.`, "file_download_done")

          setTimeout(() => {
            $(`${upidx} .bars`).css({
              "width": `0%`,
              "left": `100%`
            });
          }, 4500);
          setTimeout(() => Toast.close(`i${$(`${upidx}`).data('tidx')}`), 5000)
        }
      },

      isPlaying = (audio) => { 
        audio.onplaying = _ => $("title").text($(".head .title").text());
        audio.onpause = _ => $("title").text("Cloud Manager");
        audio.onended = _ => $("title").text("Cloud Manager");
      }

let shareck = "",
    sel_all = 0,
    cont = 0,
    upload = [];

const Start = {
  modal:"",
  
  init(){
    this.hook();

    $(".loading").css({
      "visibility": "hidden",
      "opacity": 0
    })

    window.onpopstate = (e) => {
      e.preventDefault();

      locate.rebload(100)
    }

    $("#main > .container > div:not(:first-child)").hide()

    if ($('audio')[0]) isPlaying($('audio')[0])
  },

  hook(){
    $(document)
      .on("keydown", (e) => {
        if(e.keyCode == 116){
          e.preventDefault()
          $("#main").html('')

          locate.fullreload();
        }
      })


      .on("click", ".not", (e) => e.preventDefault())


      .on("click", ".sidenav-trigger", function(e) {
        e.preventDefault()

        Start.side = $(this).data("target");
        
        $(".sidenav-overlay").css("display", "block");

        setTimeout(() => {
          $(`#${Start.side}`).css("transform", "translateX(0%)");
          $(`body`).css("overflow", "hidden");
          $(".sidenav-overlay").css("opacity", "1");
        }, 10);
      })


      .on("click", ".sidenav-overlay", function(e) {
        e.preventDefault()

        $(`#${Start.side}`).hasClass('sidenav-right')
          ? $(`#${Start.side}`).css("transform", "translateX(105%)")
          : $(`#${Start.side}`).css("transform", "translateX(-105%)");
        $(`body`).css("overflow", "auto");
        $(".sidenav-overlay").css("opacity", "0");

        setTimeout(_ => $(".sidenav-overlay").css("display", "none"), 350);
      })

      

      .on("click", ".tabs .tab a", function(e) {
        e.preventDefault()

        const target = $(this).attr("href");
        
        $("#main > .container > div").hide().removeClass("active");
        $(`${target}`).css("display", "block").addClass("active");
      })
      

      .on("click", ".modal-trigger", function(e) {
        const target = $(this).attr("href");

        if(/^(#.+)$/.exec(target)) e.preventDefault()
        
        Start.modal = target;

        $(target).show().addClass("show").parent().append(`<div class="modal-overlay"></div>`)
        $(".modal-overlay").show();

        setTimeout(() => {
          $(target).css({
            "z-index": "1003",
            "opacity": "1",
            "top": "10%",
            "transform":"scale(1)"
          });

          $(".modal-overlay").css({
            "z-index": "1002",
            "opacity": "0.5",
          });
        }, 10);
      })


      .on("click", ".modal-overlay", function(e) {
        e.preventDefault();

        sel_all = 0;
        $(`.modal input`).each(function() { this.checked = false; });

        $(`${Start.modal}`).css({
          "z-index": "1003",
          "opacity": "0",
          "top": "4%",
          "transform":"scale(0.8)"
        }).removeClass("show");

        $(".modal-overlay").css("opacity", "0");

        setTimeout(() => {
          $(`${Start.modal}`).hide();
          $(".modal-overlay").remove();
        }, 350);
      })

      .on("click", ".sel-all", function(){
        const id = $(this).data("id");

        if (sel_all == 0) {
          sel_all = 1;
          $(`#${id} input`).each(function() { this.checked = true; });
        } else{
          sel_all = 0;
          $(`#${id} input`).each(function() { this.checked = false; });
        }
      })


      .on("input", "#files", function() {
        const target = $(this)[0].files;

        target.length == 1
          ? $(".file-path-wrapper > .file-path").val(target[0].name)
          : (target.length > 1
            ? $(".file-path-wrapper > .file-path").val(`${target[0].name} 외 ${target.length - 1}개`)
            : $(".file-path-wrapper > .file-path").val(``))
      })

      
      .on("focus", "input", function() { $(`label[for=${$(this).attr("id")}]`).addClass("active") })
      .on("blur", "input", function() { if($(this).val() == "") $("label").removeClass("active") })
      .on("blur", "#life", function() { $(this).val() >= -1 ? "" : Alert.open(`접근 횟수는 ${$(this).val(-1)} 보다 작을 수 없습니다.`, "warning") })


      .on("click", ".dnt_mv_t_mv", function(e) {
        e.preventDefault();

        locate.load($(this).attr("href"))
      })


      .on("click", ".backaction", function(e){
        e.preventDefault();

        locate.start();
        $.get($(this).attr("href"), (data) => {
          Alert.open(data.trim());

          locate.load("/");
        })
      })


      .on("click", ".upload_cancel", function(){
        const idx = $(this).data('idx');

        upload[idx].abort();

        $(`.uploadidx_${idx} .upload_main_t`).text(`파일 업로드 취소`);
        $(`.i${$(`.uploadidx_${idx}`).data('tidx')} i`).text('cancel');
        $(`.uploadidx_${idx} .bars`).css("width", `100%`);
        setTimeout(() => {
          $(`.uploadidx_${idx} .bars`).css({
            "width": `0%`,
            "left": `100%`
          });
        }, 350);

        Alert.open("업로드가 취소되었습니다.", "cancel");

        setTimeout(_ => Toast.close(`i${$(`.uploadidx_${idx}`).data('tidx')}`), 3000)
      })


      .on("submit", "#form", function(e) {
        e.preventDefault(); 
      
        const ccont = cont;
        let upfiles_cnt = $("input:file")[0].files.length,
            formData = new FormData($('#form')[0]),
            size = 0,
            size_ck = 0;

        for (let i = 0; i < upfiles_cnt; i++) size += $("input:file")[0].files[i].size

        $.post("/upload/ready", (data) => { 
          size_ck = (data * 1) - size

          if (size_ck < 0) {
            Alert.open(`업로드 실패!<br> 저장공간이 ${formatBytes(Math.abs(size_ck))} 부족합니다.`, "running_with_errors");
            
            return 0;
          }

          $(this).each(function() { this.reset() }); 
        
          let oldXHR = $.ajaxSettings.xhr;
          $.ajaxSettings.xhr = function() {
            let xhr = oldXHR.apply(this, arguments);

            if (xhr instanceof window.XMLHttpRequest) xhr.addEventListener('progress', this.progress, false);
            if (xhr.upload) xhr.upload.addEventListener('progress', this.progress, false);

            return xhr;
          };

          Alert.open(`파일 ${upfiles_cnt}개를 업로드 합니다.<br>자세한 내용은 알림창을 통해 확인해주세요.`, "upload");
          Toast.open(`<div class="uploadidx_${ccont}" data-tidx="${Toast.idx}">
            <p class="upload_main_t">파일 ${upfiles_cnt}개 업로드 중 | <i class="material-icons upload_cancel" data-idx="${ccont}">cancel</i></p>
            <div>
              <p class="size"> <b class="nowupload"></b> / <b class="totaluplaod"></b></p>
              <p> <b class="per"></b></p>
            </div>
            <div class="toastClose uploadidx_${ccont} bars"></div>
          </div>`, "info");
        
          upload[ccont] = $.ajax({
            url : '/upload',
            type: 'POST',
            data: formData,
            cache: false,
            processData:false,
            contentType: false,
            progress: function(e) {
              if (e.target.response == undefined) {
                percentage = e.loaded / e.total * 100;
                progress(ccont, percentage, e.loaded, e.total);
              }
            },
            success: _ => locate.rebload(),
            error: (err) => console.log('[RCO Cloud Error] ',err.statusText)
          });

          cont++;

        }).fail(_ => Alert.open(`오류발생! 인터넷 연결여부를 확인해주십시오!`, "warning"))
      })


      .on("submit", "#Abandon, #downloada, #delete, #restone", function(e) {
        e.preventDefault(); 

        let vals = [],
            url = $(this).attr("action"),
            checkbox = $(this).find("input:checked");

        $.each(checkbox, (key, val) => vals.push($(val).val()))

        if (!vals[0]) return Alert.open('선택된 파일이 없습니다.', "warning");
        if (url == "/download") return location.href = `/download/${vals[0]}`
        
        $.post(url, {idxs: JSON.stringify(vals)}, function(data, textStatus, xhr) {
          Alert.open(data.trim(), "info");
          
          locate.rebload()
        });
      })
      
      
      .on("submit", "#unreg", function(e) {
        e.preventDefault();

        $.post($(this).attr("action"), { sure: $("#sure").val() }, function (data, textStatus, xhr) {
          if (data.trim() == "unregistered") {
            alert("탈퇴 처리가 완료되었습니다. 이용해주셔서 감사합니다.");

            location.href = "/";
          }

          Alert.open(data.trim(), "info");
        });
      })


      .on("click", ".AlertMsg", function(){
        $(this).animate({
          "height": "0px"
        }, 500, function () {
          $(this).remove();
        });
      })


      .on("click", ".change_lang", function () {
        $.ajax({
          url: '/language',
          type: 'POST',
          data: { data: $(this).data('lang') ? $(this).data('lang') : "ko" },
        })
        .done(() => {
          if ($(this).data('lang') == "ko") Alert.open("변경되었습니다.");
          else if ($(this).data('lang') == "en") Alert.open("Language Changed Successfully<br>The selected language has a wrong translation using the translator!");
          else if ($(this).data('lang') == "ja") Alert.open("言語が正常に変更されました<br>選択した言語は、翻訳を使用して誤った翻訳があります！");
          else Alert.open("변경되었습니다.");

          locate.rebload();
        })
      })


      .on("click", ".changecolor", function () {
        $.ajax({
          url: '/switch_dark',
          type: 'POST'
        })
        .done((data) => {
          $(".changecolor > i").text($(".changecolor > i").text() == "light_mode" ? "dark_mode" : "light_mode")
          data.trim() == "lightmode"
            ? $("#dark_csses").remove()
            : $("head").prepend(`<link rel="stylesheet" id="dark_csses" type="text/css" href="/assets/cloud/css/dark.css">`);
        })
      });
  }
}

const locate = {
  start: _ => $(".loading").css({ "visibility": "visible", "opacity": 1 }),
  end: _ => $(".loading").css({ "visibility": "hidden", "opacity": 0 }),

  rebload(time = ""){
    locate.start();
    const target = location.href;

    if (time == "") time = 100

    setTimeout(() => {
      $("#main").load(`${target} #main`, (response, status, xhr) => {
        if(status == "error") return alert(xhr.status == 0 ? "알 수 없는 오류가 발생하였습니다.\n리로드 후에도 정상적으로 작동하지않는다면 CTRL + R을 눌러주세요. " : `Code ${xhr.status}가 반환되었습니다.`);

        $("#main").html($("#main").html().replace(`<section id="main">`, "").replace(`</section>`, ""))

        $("#main > .container > div:not(:first-child)").hide()

        if($('audio')[0]) isPlaying($('audio')[0])

        locate.end();
      });
    }, time)
  },

  fullreload(){
    locate.start();
    const target = location.href,
      save = $("#notifi").html();

    $.ajax({
      url : `${target}`,
      success : function(result) {
        const ctnhtml = $("<html>");
        $(ctnhtml).html(result).children('meta, link, title, script').remove()

        $("#bodyload").html($(ctnhtml).html());
        $("#notifi").html(save);

        $("#main > .container > div:not(:first-child)").hide()
        $(`body`).css("overflow", "auto");

        if($('audio')[0]) isPlaying($('audio')[0])

        locate.end();
      }
    });
  },

  load(url){
    if (url.includes("#")) return;

    locate.start();
    const target = url;
    
    $("#main").load(`${target} #main`, (response, status, xhr) => {
      if(status == "error") return alert(xhr.status == 0 ? "알 수 없는 오류가 발생하였습니다.\n리로드 후에도 정상적으로 작동하지않는다면 CTRL + R을 눌러주세요. " :  `Code ${xhr.status}가 반환되었습니다.`);

      history.pushState("", "", target)
      $("#main").html($("#main").html().replace(`<section id="main">`, "").replace(`</section>`, ""))
      
      $("#main > .container > div:not(:first-child)").hide()

      if($('audio')[0]) isPlaying($('audio')[0])

      locate.end();
    });
  }
}

const edit = {
  save(idx, msg){
    $("#share").is(":checked") ? shareck = "1" : shareck = "0";
    $.ajax({
      url: `/edit/${idx}`,
      type: 'POST',
      data: {
        filename: $("#filename").val(),
        check: $("#check").val(),
        share: shareck,
        life: $("#life").val(),
        note: $("#note").val()
      }
    })
    .done(_ => {
      Alert.open(msg.trim());
      locate.rebload();
    })
  }
}

const Toast = {
  idx : 0,
  open(msg, type) {
    Toast.new(msg, type);
    Toast.idx++
  },

  alert() {
    $(`.j${i}`).animate({
      "width": "100%"
    }, 5000, "linear", () => {
      Toast.close(`i${i}`);
    });
  },

  new(tst, type) {
    $(".ctoast").append(`<div class="toastMsg i${Toast.idx}">
      <i class="material-icons small">${type}</i>
      <div class="msgs"> ${tst} </div>
      </div>`)

    $(`.i${Toast.idx}`).animate({
      "marginLeft": "0px"
    }, 500);
  },

  close(clss) {
    $(clss ? `.${clss}` : this).animate({
      "height": "0px"
    }, 500, function() {
      $(clss ? `.${clss}` : this).remove();
    });
  }
}

const Alert = {
  i: 0,
  open(tst, icon = "info") {
    let i = Alert.i;
    $(".Alert").append(`<div class="AlertMsg Al${i}">
      <i class="material-icons">${icon}</i>
      <div class="msgs">
        ${tst}
      </div>
      <div class="AlertClose Alc${Alert.i}"></div>
      </div>`)

    $(`.Al${i}`).animate({ "marginLeft": "0px" }, 500);
    $(`.Alc${i}`).animate({ "width": "100%" }, 5000, "linear", () => {
      Alert.close(`Al${i}`);
    });
    Alert.i++
  },

  close(clss) {
    $(clss ? `.${clss}` : this).animate({
      "height": "0px"
    }, 500, function() {
      $(clss ? `.${clss}` : this).remove();
    });
  }
}


$(_ => { Start.init() })