<?php 

	$sample_name = session_name("session");
  session_set_cookie_params(0, "/", "rococpy.com");
	session_start();

	date_default_timezone_set("Asia/Seoul");

	define("USER", @$_SESSION['user']);
	define("ROOT", $_SERVER['DOCUMENT_ROOT']);
	define("FILE_ROOT", str_replace("/cloud_web", "/cloud_file", $_SERVER['DOCUMENT_ROOT']));
	
	function dd() { 
		echo "<pre>"; 
			var_dump(...func_get_args());
		echo "</pre>";
	}

	function move($url, $msg = false) {
		if (is_array($msg)) {
			$msg = implode("\\n", $msg);
		}

		if ($msg) {
			echo "<script>alert('$msg')</script>";
		}

		$url = $url == "back" ? "history.back()" : "location.href='$url'";

		echo "<script>$url</script>";
		exit;
	}

	function view_data($loc, $data = []) {
		extract($data);

		require ROOT."/mvc/view/$loc.php";
	}

	function view($loc, $data = []) {
		extract($data);

		require ROOT."/mvc/view/cloud/header.php";
		require ROOT."/mvc/view/cloud/$loc.php";
		require ROOT."/mvc/view/cloud/footer.php"; 
	}

	function arr($a) {
		return is_array($a) ? $a : [$a];
	}

	function unslash($s) {
		return str_replace("/\\/g", "", $s);
	}

	function validator($post, $arr = []) { 
		return array_filter($arr, function($v, $k) {
			return trim($post[$k]) == "";
		}, ARRAY_FILTER_USE_BOTH);
	}

	function img_up($img) {
		$micro = microtime();
		$fn = md5($micro.$img["name"]);

		$ext = pathinfo($img['name'], PATHINFO_EXTENSION);

		move_uploaded_file($img['tmp_name'], ROOT."/resources/uploaded/$fn.$ext");

		return "/resources/uploaded/$fn.$ext";
	}

	function responseJSON($json) {
		header("Content-Type: application/json");
		echo json_encode($json);
	}

	function gview($loc, $data = []) {
		extract($data);

		require ROOT."/mvc/view/guest/$loc.php";
	}

	function err($error, $loc, $msg) {
		if ($error) {
			move($loc, $msg);
		}
	}

	function formatSize($bytes, $decimals = 2) {
	  $size = array('B', 'KB', 'MB', 'GB', 'TB', 'PB', 'EB', 'ZB', 'YB');
	  $factor = floor((strlen($bytes) - 1) / 3);
	  return sprintf("%.{$decimals}f", $bytes / pow(1024, $factor)) . @$size[$factor];
	}

    function getBrowser() {
	    $broswerList = array('MSIE', 'Chrome', 'Firefox', 'iPhone', 'iPad', 'Android', 'PPC', 'Safari', 'Trident', 'none');
	    $browserName = 'none';
	    
	    foreach ($broswerList as $userBrowser){
        if($userBrowser === 'none') break;
        if(strpos($_SERVER['HTTP_USER_AGENT'], $userBrowser)) {
          $browserName = $userBrowser;
          break;
        }
	    }

	    return $browserName;
	}
 
	function isBlockBrowser() {
		$BrowserName = getBrowser();
		if($BrowserName === 'MSIE'||$BrowserName === 'Trident'){
			echo("죄송합니다. Internet Explorer를 통한 접속은 차단하고 있습니다. <br><a href='https://www.microsoft.com/ko-kr/edge'>New Edge</a>, <a href='https://www.google.com/intl/ko/chrome/'>Chrome</a>또는 <a href='https://www.mozilla.org/ko/firefox/new/'>FireFox</a> 등 차세대 브라우저를 이용해주십시오."); 
			die;
		}
	}

	function files_format($data){
		foreach ($data as $key => $value) {
			foreach ($value as $key1 => $value1) {
				$redata[$key1][$key] = $value1;
			}
		}
		return $redata;
	}

	function smartReadFile($location, $filename, $mimeType = 'application/octet-stream') {
	  if (!file_exists($location)){
	    header ("HTTP/1.1 404 Not Found");
	    return;
	  }
	  
	  $size = filesize($location);
	  $time = date('r', filemtime($location));
	  $mimeType = mime_content_type($location);
	  
	  $fm   = @fopen($location, 'rb');
	  if (!$fm) {
	    header ("HTTP/1.1 505 Internal server error");
	    return;
	  }
	  
	  $begin  = 0;
	  $end  = $size - 1;
	  
	  if (isset($_SERVER['HTTP_RANGE']) && preg_match('/bytes=\h*(\d+)-(\d*)[\D.*]?/i', $_SERVER['HTTP_RANGE'], $matches)) {
	      $begin  = intval($matches[1]);

	      if (!empty($matches[2])) $end  = intval($matches[2]);
	  }

	  isset($_SERVER['HTTP_RANGE']) ? header('HTTP/1.1 206 Partial Content') : header('HTTP/1.1 200 OK');
	  
	  header("Content-Type: $mimeType"); 
	  header('Cache-Control: public, must-revalidate, max-age=0');
	  header('Pragma: no-cache');  
	  header('Accept-Ranges: bytes');
	  header('Content-Length:' . (($end - $begin) + 1));
	  if (isset($_SERVER['HTTP_RANGE'])) header("Content-Range: bytes $begin-$end/$size");
	  header("Content-Disposition: inline; filename=$filename");
	  header("Content-Transfer-Encoding: binary");
	  header("Last-Modified: $time");
	  
	  $cur  = $begin;
	  fseek($fm, $begin, 0);
	  
	  while(!feof($fm) && $cur <= $end && (connection_status() == 0)) {
	    print fread($fm, min(1024 * 16, ($end - $cur) + 1));
	    $cur += 1024 * 16;
	  }
	}



 ?>